class GrenadesForLaunching : Ammo replaces RocketAmmo
	{
		  default {
			 Inventory.Pickupsound ("m79load");
			 Inventory.Amount 1;
			 Inventory.MaxAmount 32;
			 Ammo.BackpackAmount 2; // How much you'll get out of backpacks or equivalent.
			 Ammo.BackpackMaxAmount 64; // The new max amount if player has a backpack.
			 Inventory.PickupMessage "\cjGrabbed a 40mm Grenade.";
			 }
			States
				  {
				  Spawn:
					GREN A 1;
					Loop;
		}
	}

class GrenadeBox : GrenadesForLaunching replaces RocketBox
	{
	default {
		Inventory.Pickupsound ("pick_boxammo");
		Inventory.Amount 5;
		Inventory.PickupMessage "\cjCaptured a Crate of 40mm Grenades!";
		}
		
			States
				  {
				  Spawn:
					GREN B 1;
					Loop;
		}
	}
		
Class BigBlammo : Actor
	{
	DEFAULT
	{
	scale 3;
	}
	States
		{
		Spawn:
		XPLA A 0;
		Death:
		XPLA A 1 Bright { 
				A_Explode(150, 200, fulldamagedistance: 60); 
				A_QuakeEx( 5, 5, 5, 60, 0, 3000 ); A_Playsound("Explosion1", CHAN_WEAPON, attenuation:ATTN_NONE ); 
				A_AttachLightDef("TheBigBangTheory", "BigBoom2");
			}
		XPLA BCD 1 Bright A_AttachLightDef("TheBigBangTheory", "BigBoom2");
		XPLA EFG 1 Bright A_AttachLightDef("TheBigBangTheory", "BigBoom1");
		XPLA HIJKL 1 Bright A_AttachLightDef("TheBigBangTheory", "BigBoom2");
		XPLA MNOP 1 Bright A_RemoveLight('TheBigBangTheory');
		Stop;
		}
}
class M79Gren : Grenade
{
	DEFAULT
	{
		scale 1;
		Speed 30;
		Bouncesound "dong";
		+GRENADETRAIL
		Gravity .4;
	}
	States
			  {
			  Spawn:
				GRND A 1;
				Loop;	
			  Death:
				TNT1 A 0 A_SpawnItemEx("BigBlammo");
				Stop;
			  }	 
}

class M79 : ZWeapon replaces RocketLauncher 
{
	Default
	{
		scale 1.25;
		weapon.slotnumber 5;
		Weapon.SelectionOrder 1300;
		Weapon.AmmoUse 1;
		Weapon.BobStyle "InverseSmooth";
		//Weapon.Bobspeed 2;
		Weapon.BobRangeX .45;
		Weapon.BobRangeY .35;
		Weapon.AmmoGive 1;
		ZWeapon.MagazineSize 1;
		ZWeapon.ClickSound "Dryfire";
		Weapon.AmmoType "GrenadesForLaunching";
		Inventory.PickupMessage "\cjMustered up an M79 Grenade Launcher!";
		Obituary "$OB_MPSHOTGUN";
		Tag "M79";
	}
	States
	{
	Ready:
		FUMP A 1 ZWL_WeaponReady;
		Loop;
	Deselect:
		FUMP A 1 A_Lower(9);
		Loop;
	Select:
		FUMP A 1 A_Raise(9);
		Loop;
	FailFire: 
		FUMP A 3 A_StartSound ("Dryfire");
		FUMP A 0{
            if (CountInv ("GrenadesForLaunching") == 0)
                return ResolveState ("CancelReload"); // If ANY of the above is true — go back to Ready state and don't try to reload
            return ResolveState ("Ready"); // OTHERWISE continue
        }
	Fire:
	//note: sucks
		FUMP A 0 ZWL_Jumpifempty("FailFire"); 
		FUSM A 1 { A_FireProjectile("M79Gren", angle: 0, useammo: true, flags: FPF_NOAUTOAIM, pitch: -5); A_Playsound("m79"); A_Weaponoffset(0,58); 
				   A_SetPitch (pitch - (Anderson_Kick * 1.2), SPF_INTERPOLATE);}
		FUSM A 1;
		FUSM AA 1 A_SetPitch (pitch + (Anderson_Kick * 0.3), SPF_INTERPOLATE);
		FUSM BB 1 A_SetPitch (pitch + (Anderson_Kick * 0.3), SPF_INTERPOLATE);
		FUMP A 1;
		FUMP AAAA 1 A_Weaponoffset(0,-6, WOF_ADD);
		
		//Fallthrough
	ReloadNorm:
		M79F CCBBBB 1 A_SetPitch (pitch - (Anderson_Kick * .75), SPF_INTERPOLATE);
		M79F BBCCDD 1 A_SetPitch (pitch + (Anderson_Kick * .75), SPF_INTERPOLATE);
		
		FUMP D 9 { A_Playsound("THUMP_OPEN"); ZWL_EjectCasing("FortyMilCase", true, -45, 5, 12, (24, 0, -16));}
		FUMP D 1 {
            if (CountInv ("GrenadesForLaunching") == 0)
                return ResolveState ("CancelReload"); // If ANY of the above is true — go back to Ready state and don't try to reload
            return ResolveState (null); // OTHERWISE continue
        }
		M79R AABCDEF 1; //loading
		M79R GHI 1;
		M79R J 1 {A_Playsound("m79load"); ZWL_Reload(1); A_Weaponoffset (2,2, WOF_ADD); 
				A_SetAngle (Angle - (Anderson_Kick * .3));
				A_SetPitch (Pitch + (Anderson_Kick * .3));}
		M79R JJJ 1 { A_Weaponoffset (2,2, WOF_ADD); 
			A_SetAngle (Angle - (Anderson_Kick * .3));
			A_SetPitch (Pitch + (Anderson_Kick * .3));}
		M79R J 4;
		M79R KLMN 1; 
		M79R OPQR 1 { A_Weaponoffset (-1,-1, WOF_ADD); A_SetAngle (Angle + (Anderson_Kick * .3));
				A_SetPitch (Pitch - (Anderson_Kick * .3));}
		M79R S 6; 
		
		TNT1 A 0 A_Playsound("THUMP_CLOSE");
		M79F DDCCBB 1 A_SetPitch (pitch - (Anderson_Kick * .75), SPF_INTERPOLATE);
		M79F BBBBCC 1 A_SetPitch (pitch + (Anderson_Kick * .75), SPF_INTERPOLATE);
		TNT1 A 0 A_Weaponoffset(0,32);
		Goto Ready; 
	Reload:
		FUMP D 0 {
            if (CountInv ("GrenadesForLaunching") == 0)
                return ResolveState ("Ready"); // If ANY of the above is true — go back to Ready state and don't try to reload
            return ResolveState (null); // OTHERWISE continue
        }
		M79F CCBBBB 1 A_SetPitch (pitch - (Anderson_Kick * .75), SPF_INTERPOLATE);
		M79F BBCCDD 1 A_SetPitch (pitch + (Anderson_Kick * .75), SPF_INTERPOLATE);
		
		FUMP D 9 { A_Playsound("THUMP_OPEN"); ZWL_EjectCasing("FortyMilCase", true, -45, 5, 12, (24, 0, -16));}
		FUMP D 1 {
            if (CountInv ("GrenadesForLaunching") == 0)
                return ResolveState ("CancelReload"); // If ANY of the above is true — go back to Ready state and don't try to reload
            return ResolveState (null); // OTHERWISE continue
        }
		M79R AABCDEF 1; //loading
		M79R GHI 1;
		M79R J 1 {A_Playsound("m79load"); ZWL_Reload(1); A_Weaponoffset (2,2, WOF_ADD); 
				A_SetAngle (Angle - (Anderson_Kick * .3));
				A_SetPitch (Pitch + (Anderson_Kick * .3));}
		M79R JJJ 1 { A_Weaponoffset (2,2, WOF_ADD); 
			A_SetAngle (Angle - (Anderson_Kick * .3));
			A_SetPitch (Pitch + (Anderson_Kick * .3));}
		M79R J 4;
		M79R KLMN 1; 
		M79R OPQR 1 { A_Weaponoffset (-1,-1, WOF_ADD); A_SetAngle (Angle + (Anderson_Kick * .3));
				A_SetPitch (Pitch - (Anderson_Kick * .3));}
		M79R S 6; 
		
		TNT1 A 0 A_Playsound("THUMP_CLOSE");
		M79F DDCCBB 1 A_SetPitch (pitch - (Anderson_Kick * .75), SPF_INTERPOLATE);
		M79F BBBBCC 1 A_SetPitch (pitch + (Anderson_Kick * .75), SPF_INTERPOLATE);
		TNT1 A 0 A_Weaponoffset(0,32);
		Goto Ready;
	CancelReload:
		M79F D 2 A_Playsound("THUMP_CLOSE");
		M79F DDCCBB 1 A_SetPitch (pitch - (Anderson_Kick * .75), SPF_INTERPOLATE);
		M79F BBBBCC 1 A_SetPitch (pitch + (Anderson_Kick * .75), SPF_INTERPOLATE);
		goto ready;
	
	Flash:
		REMF A 2 Bright A_Light1;
		REMF B 2 Bright A_Light2;
		REMF C 1 Bright A_Light2;	
		Goto LightDone;
	Spawn:
		GLNC H -1;
		Stop;

	}
	

}

