class ImpactPuff : actor
{
	default
	{
		+NOBLOCKMAP
		+NOGRAVITY
		+ALLOWPARTICLES
		+PUFFGETSOWNER
		+PUFFONACTORS
	}
	States
	{
	Spawn:
		TNT1 A 0 NoDelay { A_Quake(2, 3, 0, 400, ""); A_StartSound("PipeClang",CHAN_AUTO);}
		CLNG ABCD 1;
		stop;
	}
}

class LeadPipe : Weapon
{ 
	bool hitenemy;
	bool bSwing;
	Default 
	{
		Scale 1.2;
		Weapon.SelectionOrder 99999;
		weapon.slotnumber 1;
		Weapon.BobStyle "InverseSmooth";
		Inventory.PickupMessage "\cjLoaned a Lead Pipe!";
		Weapon.Bobspeed 1.1;
		Weapon.KickBack 320;
		+WEAPON.MELEEWEAPON
		+WEAPON.NOALERT
	}
	states
	{
	Select:
	    PIPE A 0 A_OverlayFlags(1,PSPF_FLIP|PSPF_MIRROR, False); 
		PIPE X 1 
		{ 
			A_WeaponOffset (0, 96); 
			A_Overlay(4, "LoneSwingSprite"); 
			A_OverlayPivot(4, 2, 3); 
			A_OverlayRotate (4, -96); 
		}
		PIPE XXXXXX 1 
		{ 
			A_WeaponOffset (0, -8, WOF_ADD); 
			A_OverlayRotate (4, 8,WOF_ADD);
		}
		PIPE XXXXXX 1 A_OverlayRotate (4, 8,WOF_ADD);
		PIPE A 0 
		{
			A_Startsound("PipePap"); 
			A_ClearOverlays(4,4);
		}
		goto ready;
	Deselect:
		PIPE A 1 A_Lower(12);
		loop;
	Ready:
		PIPE A 1 
		{ 
			A_Weaponready(WRF_ALLOWRELOAD); 
			Invoker.bSwing = True;
		}
		loop;
	 Reload: 
		PIPE X 0 {A_Overlay(4, "LoneSwingSprite"); 
				  A_OverlayPivot(4, 1, 2);}
		PIPE XXXX 1 { A_OverlayRotate (4, -4, WOF_ADD); A_OverlayOffset(4, 0, -3, WOF_ADD); 
				A_SetPitch (pitch - (Anderson_Kick * 0.2), SPF_INTERPOLATE);}
		PIPE XX 1 { A_OverlayRotate (4, -3, WOF_ADD); A_OverlayOffset(4, 0, -3, WOF_ADD); 
				A_SetPitch (pitch - (Anderson_Kick * 0.2), SPF_INTERPOLATE);} 
		PIPE XX 1 { A_OverlayRotate (4, -2, WOF_ADD); A_OverlayOffset(4, 0, -3, WOF_ADD); 
				A_SetPitch (pitch - (Anderson_Kick * 0.2), SPF_INTERPOLATE);}
		PIPE X 5;
		PIPE XX 1 { A_OverlayRotate (4, 2, WOF_ADD); A_OverlayOffset(4, 0, 3, WOF_ADD); 
				A_SetPitch (pitch + (Anderson_Kick * 0.2), SPF_INTERPOLATE);}
		PIPE XX 1 { A_OverlayRotate (4, 3, WOF_ADD); A_OverlayOffset(4, 0, 3, WOF_ADD); 
				A_SetPitch (pitch + (Anderson_Kick * 0.2), SPF_INTERPOLATE);}
		PIPE XXXXX 1 { A_OverlayRotate (4, 4,WOF_ADD); A_OverlayOffset(4, 0, 3, WOF_ADD); 
				A_SetPitch (pitch + (Anderson_Kick * 0.2), SPF_INTERPOLATE);}
		TNT1 A 0 {A_Startsound("PipePap");  A_ClearOverlays(4,4); }
		PIPE AAA 1 A_Weaponoffset(0,3, WOF_ADD);
		PIPE AAA 1 A_Weaponoffset(0,-3, WOF_ADD);
		goto ready;

	 Fire:
		PIPE AAAAAAA 1 A_WeaponOffset (0, 10, WOF_ADD);
	 Hold:
	    TNT1 A 0 
		{ 
			A_OverlayPivot(1, 2, 3); 
			if (Invoker.bSwing)
			{
				A_OverlayFlags(1, PSPF_FLIP|PSPF_MIRROR, True);
				Invoker.bSwing = False;
				A_Jump(255, "LeftSwing");

			}
			else
			{
				A_OverlayFlags(1, PSPF_FLIP|PSPF_MIRROR, False);
				Invoker.bSwing = True;
			}
		}
		
	RightSwing:
		TNT1 A 0 A_Startsound("PipeSwing");
		
		PIPE BBB 1 
		{
			A_Weaponoffset(-450, 210); 
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle+1.5,SPF_INTERPOLATE);
		}
		PIPE BBBB 1 
		{
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle+2.5,SPF_INTERPOLATE);
		}
		PIPE B 1 
		{
			A_CustomPunch(30, norandom:TRUE,Flags:CPF_DAGGER|CPF_NOTURN, pufftype:"ImpactPuff", meleesound:"" , 0); 
			A_OverlayRotate (1, -8, WOF_ADD);
			 A_SetAngle(Angle-2.5,SPF_INTERPOLATE);}
		
		PIPE BBB 1 
		{
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle-2.5,SPF_INTERPOLATE);
		}
		PIPE BBB 1 
		{
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle-1.5,SPF_INTERPOLATE);
		}
		TNT1 A 9;
		PIPE A 0 
		{ 
			A_ReFire("Hold"); 
			A_OverlayRotate (1, 0);
		}
		Goto Select;
		
	LeftSwing:
		TNT1 A 0 A_Startsound("PipeSwing");
		
		PIPE BBB 1 
		{
		
			A_Weaponoffset(-450, 210); 
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle-1.5,SPF_INTERPOLATE);
		}
		PIPE BBBB 1 
		{
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle-2.5,SPF_INTERPOLATE);
		}
		PIPE B 1 
		{
			A_CustomPunch(30, norandom:TRUE,Flags:CPF_DAGGER|CPF_NOTURN, pufftype:"ImpactPuff", meleesound:"" , 0); 
			A_OverlayRotate (1, -8, WOF_ADD);
			 A_SetAngle(Angle+2.5,SPF_INTERPOLATE);}
		
		PIPE BBB 1 
		{
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle+2.5,SPF_INTERPOLATE);
		}
		PIPE BBB 1 
		{
			A_OverlayRotate (1, -8, WOF_ADD);
			A_SetAngle(Angle+1.5,SPF_INTERPOLATE);
		}
		TNT1 A 9;
		PIPE A 0 
		{ 
			A_ReFire("Hold"); 
			A_OverlayRotate (1, 0);
		}
		Goto Select;
	LoneSwingSprite:
		PIPE B 1;
		Loop;
	Spawn:
		PIPP a 1;
		loop;
	}
}